/*
	CreateTemplateFileCmd.h - make new blank template file

	Will Eighteen, 2000: will@opaline.demon.co.uk
*/

#ifndef CREATETEMPLATEFILECMD_H
#define CREATETEMPLATEFILECMD_H

#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif


#define BUFSIZE 1024


class FileAccess;


class CreateTemplateFileCmd : public BreakCmd
{
	public:
		CreateTemplateFileCmd ( char *, int, char *, long, long, int );
		virtual ~CreateTemplateFileCmd();
		char *target() { return _dstFile; };
		int error() { return _error; }
		void setDefaultValue ( float num ) { _defaultValue = num; }

	protected:
		void doCommand();
		
	private:
		long _blockLength;
		long _numSamples;
		long _samplesWritten;
		int _once;
		int _percentDone;
		int  _error, _dataType;
		char _dstFile[BUFSIZE];
		float _defaultValue;
		FileAccess *_dst;
		char *_name;
		unsigned int _bytesPerSample;
};

#endif
