/*
	DeletePakCmd.cc

	Will Eighteen, 2001: will@opaline.demon.co.uk
*/

#include "AppWindow.h"
#include "DeletePakCmd.h"
#include <GraphFltCmd.h>
#include <GraphIntCmd.h>
#include <InfoDialogManager.h>
#include <MessageDialogManager.h>


DeletePakCmd::DeletePakCmd ( const char *name, int active ) : NoUndoCmd ( name, active )
{
	// empty
}


void DeletePakCmd::doCommand()
{
	if ( mixwaveResources->waveCtrlRealised() == True )
	{
		char msg[58];
		strcpy ( msg, "Delete rejected - please close wave control menu first." );
		messageDialogManager->post ( msg );
		return;
	}
	
	int count;
	int error = 0;

	for ( count = 0; count < wavePak->Count(); count++ )
	{
		if ( (*wavePak)[count].fLock == ACTIVE )
		{
			char msg [strlen((*wavePak)[count].pWave->name())+40];
			snprintf ( msg, sizeof ( msg ), "%s\ndelete rejected - wave is being \
used.", (*wavePak)[count].pWave->name() );
			messageDialogManager->post ( msg );
			error++;
		}
	}

	for ( count = 0; count < templatePak->Count(); count++ )
	{
		if ( (*templatePak)[count].fLock == ACTIVE )
		{
			char msg [strlen((*templatePak)[count].name)+48];
			snprintf ( msg, sizeof ( msg ), "%s\ndelete rejected - template is being \
used.", (*templatePak)[count].name );
			messageDialogManager->post ( msg );
			error++;
		}
	}

	if ( error )
	{
		char msg[45];
		strcpy ( msg, "'Delete all' command rejected: files in use." );
		messageDialogManager->post ( msg );
		return;
	}
			
	for ( count = 0; count < wavePak->Count(); count++ )
	{
		delete (*wavePak)[count].pWave;
		
		if ( (*wavePak)[count].pIntArray != NULL )			// absent unless wave edited
			delete[] (*wavePak)[count].pIntArray;
		
		if ( (*wavePak)[count].graphCmd != NULL )			// absent unless wave edited
		{
			(*wavePak)[count].graphCmd->close();
			delete (*wavePak)[count].graphCmd;
		}

		(*wavePak)[count].graphNum = 0;
		(*wavePak)[count].intArraySize = 0;
		(*wavePak)[count].startRange = 0;
		(*wavePak)[count].endRange = 0;
		(*wavePak)[count].startSel = 0;
		(*wavePak)[count].endSel = 0;
		(*wavePak)[count].xCurrent = 0;
		(*wavePak)[count].yCurrent = 0;
		(*wavePak)[count].dataOffset = 0;

		if ( (*wavePak)[count].waveDataCmd != NULL )
		{
			(*wavePak)[count].waveDataCmd->cancel();
			delete (*wavePak)[count].waveDataCmd;
		}
			
		(*wavePak)[count].infoNum = 0;
		(*wavePak)[count].fLock = 0;
		(*wavePak)[count].revision = 0;
		(*wavePak)[count].waveChanged = False;
	}
	
	wavePak->Release();	// delete list of wavePak structures

	for ( int count = 0; count < templatePak->Count(); count++ )
	{
		(*templatePak)[count].name[0] = 0;
		(*templatePak)[count].syncFile[0] = 0;
		
		if ( (*templatePak)[count].graphIntCmd != NULL )
		{
			(*templatePak)[count].graphIntCmd->close();
			delete (*templatePak)[count].graphIntCmd;
		}		
		
		if ( (*templatePak)[count].graphFltCmd != NULL )
		{
			(*templatePak)[count].graphFltCmd->close();
			delete (*templatePak)[count].graphFltCmd;
		}
		
		(*templatePak)[count].intArraySize = 0;
		(*templatePak)[count].fltArraySize = 0;
			
		if ( (*templatePak)[count].pIntArray != NULL )
			delete (*templatePak)[count].pIntArray;
		
		if ( (*templatePak)[count].pFloatArray != NULL )
			delete (*templatePak)[count].pFloatArray;
		
		(*templatePak)[count].file = NULL;
	}

	templatePak->Release();	// delete list of templatePak structures
	
	mixPak->Release();	// delete list of mixPak structures
}
