/*
    ShapeTemplateCmd.h - function plotter for templates

    Will Eighteen, 2001: will@opaline.demon.co.uk
*/

#ifndef SHAPETEMPLATECMD_H
#define SHAPETEMPLATECMD_H


#ifndef BREAK
#define BREAK
#include <BreakCmd.h>
#endif

#include <NoUndoCmd.h>


class DMenuCmd;
class DataConformCmd;


class ShapeTemplateCmd : public NoUndoCmd
{
	public:
		ShapeTemplateCmd ( char *, int, unsigned int, unsigned int );

	protected:
		virtual void doCommand();	// ShapeTemplate

	private:
		static void dataConformFinishedCallback ( BreakCmd *, Boolean, void * );
		void dataConformFinished ( DataConformCmd * );

		// callback for WM 'X'
		static void clientMessageProc ( Widget, XtPointer, XmAnyCallbackStruct * );
static void quitCallback ( Widget, XtPointer, XtPointer );
		static void templateMenuSelectionCallback ( void *, unsigned int, char * );
		static void templateSelCallback ( Widget, XtPointer, XtPointer );

		// function button callbacks
		static void funct1Callback ( Widget, XtPointer, XtPointer );
		static void funct2Callback ( Widget, XtPointer, XtPointer );
		static void funct3Callback ( Widget, XtPointer, XtPointer );
		static void funct4Callback ( Widget, XtPointer, XtPointer );
		static void funct5Callback ( Widget, XtPointer, XtPointer );
		static void funct6Callback ( Widget, XtPointer, XtPointer );

		// Callbacks for data change by user
		static void field1aEntryCallback ( Widget, XtPointer, XtPointer );
		static void field1bEntryCallback ( Widget, XtPointer, XtPointer );

		static void field2aEntryCallback ( Widget, XtPointer, XtPointer );
		static void field2bEntryCallback ( Widget, XtPointer, XtPointer );

		static void field3aEntryCallback ( Widget, XtPointer, XtPointer );
		static void field3bEntryCallback ( Widget, XtPointer, XtPointer );

		static void field4aEntryCallback ( Widget, XtPointer, XtPointer );
		static void field4bEntryCallback ( Widget, XtPointer, XtPointer );

		static void field5aEntryCallback ( Widget, XtPointer, XtPointer );
		static void field5bEntryCallback ( Widget, XtPointer, XtPointer );

		static void field6aEntryCallback ( Widget, XtPointer, XtPointer );
		static void field6bEntryCallback ( Widget, XtPointer, XtPointer );

		// fns called when data in text box is changed
		void field1aEntry ( char * );
		void field1bEntry ( char * );
		void changeField1a ( float );
		void changeField1b ( float );

		void field2aEntry ( char * );
		void field2bEntry ( char * );
		void changeField2a ( float );
		void changeField2b ( float );

		void field3aEntry ( char * );
		void field3bEntry ( char * );
		void changeField3a ( float );
		void changeField3b ( float );

		void field4aEntry ( char * );
		void field4bEntry ( char * );
		void changeField4a ( float );
		void changeField4b ( float );

		void field5aEntry ( char * );
		void field5bEntry ( char * );
		void changeField5a ( float );
		void changeField5b ( float );

		void field6aEntry ( char * );
		void changeField6a ( unsigned int );
		void field6bEntry ( char * );
		void changeField6b ( float );
		int clientMessage ( XmAnyCallbackStruct * );

		int checkTextEntry ( char * );
		void templateSel();
		void readData();
		void writeData();
		void quit();
		void templateSelected ( unsigned int );
		void setTitle ( char * );
		void funct1 ( float, float );	// line interpolation
		void funct2 ( float, float );	// sinusoid
		void funct3 ( float, float );	// tangent
		void funct4 ( float, float );	// exponential
		void funct5 ( float, float );	// natural log.
		void funct6 ( unsigned int, float );	// curve fit

		Boolean _shapeTemplateRealised;
		Boolean _templateRealised;
		int *_idata;
		float *_fdata;
		DMenuCmd *_templateMenu;
		const char *_name;
		long _startData, _endData, _dataOffset;
		int _dataType;
		unsigned int _numDigits;
		unsigned int _fpDigits;
		unsigned int _selectedItemNum;
		unsigned _templateArrayItems;
		Widget _rc1, _funct1, _label1a, _label1b, _field1a, _field1b;
		Widget _rc2, _funct2, _label2a, _label2b, _field2a, _field2b;
		Widget _rc3, _funct3, _label3a, _label3b, _field3a, _field3b;
		Widget _rc4, _funct4, _label4a, _label4b, _field4a, _field4b;
		Widget _rc5, _funct5, _label5a, _label5b, _field5a, _field5b;
		Widget _rc6, _funct6, _label6a, _label6b, _field6a, _field6b;
		Widget _popup, _form, _label, _templateSel, _sep, _quit;
};

#endif

